diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 5329432f25..7b405cb05c 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -569,7 +569,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 %type <node>	filter_clause
 %type <list>	window_clause window_definition_list opt_partition_clause
 %type <windef>	window_definition over_clause window_specification
-				opt_frame_clause frame_extent frame_bound
+				opt_frame_clause frame_extent frame_bound opt_window_exclusion_clause
 %type <str>		opt_existing_window_name
 %type <boolean> opt_if_not_exists
 %type <ival>	generated_when override_kind
@@ -632,7 +632,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 	FALSE_P FAMILY FETCH FILTER FIRST_P FLOAT_P FOLLOWING FOR
 	FORCE FOREIGN FORWARD FREEZE FROM FULL FUNCTION FUNCTIONS
 
-	GENERATED GLOBAL GRANT GRANTED GREATEST GROUP_P GROUPING
+	GENERATED GLOBAL GRANT GRANTED GREATEST GROUP_P GROUPING GROUPS
 
 	HANDLER HAVING HEADER_P HOLD HOUR_P
 
@@ -656,7 +656,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 	NULLS_P NUMERIC
 
 	OBJECT_P OF OFF OFFSET OIDS OLD ON ONLY OPERATOR OPTION OPTIONS OR
-	ORDER ORDINALITY OUT_P OUTER_P OVER OVERLAPS OVERLAY OVERRIDING OWNED OWNER
+	ORDER ORDINALITY OTHERS OUT_P OUTER_P OVER OVERLAPS OVERLAY OVERRIDING OWNED OWNER
 
 	PARALLEL PARSER PARTIAL PARTITION PASSING PASSWORD PLACING PLANS POLICY
 	POSITION PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
@@ -676,7 +676,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 	SUBSCRIPTION SUBSTRING SYMMETRIC SYSID SYSTEM_P
 
 	TABLE TABLES TABLESAMPLE TABLESPACE TEMP TEMPLATE TEMPORARY TEXT_P THEN
-	TIME TIMESTAMP TO TRAILING TRANSACTION TRANSFORM TREAT TRIGGER TRIM TRUE_P
+	TIES TIME TIMESTAMP TO TRAILING TRANSACTION TRANSFORM TREAT TRIGGER TRIM TRUE_P
 	TRUNCATE TRUSTED TYPE_P TYPES_P
 
 	UNBOUNDED UNCOMMITTED UNENCRYPTED UNION UNIQUE UNKNOWN UNLISTEN UNLOGGED
@@ -725,8 +725,8 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
  * various unreserved keywords as needed to resolve ambiguities (this can't
  * have any bad effects since obviously the keywords will still behave the
  * same as if they weren't keywords).  We need to do this for PARTITION,
- * RANGE, ROWS to support opt_existing_window_name; and for RANGE, ROWS
- * so that they can follow a_expr without creating postfix-operator problems;
+ * RANGE, ROWS, or GROUPS to support opt_existing_window_name; and for RANGE, ROWS
+ * or GROUPS so that they can follow a_expr without creating postfix-operator problems;
  * for GENERATED so that it can follow b_expr;
  * and for NULL so that it can follow b_expr in ColQualList without creating
  * postfix-operator problems.
@@ -746,7 +746,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
  * blame any funny behavior of UNBOUNDED on the SQL standard, though.
  */
 %nonassoc	UNBOUNDED		/* ideally should have same precedence as IDENT */
-%nonassoc	IDENT GENERATED NULL_P PARTITION RANGE ROWS PRECEDING FOLLOWING CUBE ROLLUP
+%nonassoc	IDENT GENERATED NULL_P PARTITION RANGE ROWS GROUPS PRECEDING FOLLOWING CUBE ROLLUP
 %left		Op OPERATOR		/* multi-character ops and user-defined operators */
 %left		'+' '-'
 %left		'*' '/' '%'
@@ -14003,7 +14003,7 @@ window_specification: '(' opt_existing_window_name opt_partition_clause
 		;
 
 /*
- * If we see PARTITION, RANGE, or ROWS as the first token after the '('
+ * If we see PARTITION, RANGE, ROWS or GROUPS as the first token after the '('
  * of a window_specification, we want the assumption to be that there is
  * no existing_window_name; but those keywords are unreserved and so could
  * be ColIds.  We fix this by making them have the same precedence as IDENT
@@ -14023,33 +14023,43 @@ opt_partition_clause: PARTITION BY expr_list		{ $$ = $3; }
 /*
  * For frame clauses, we return a WindowDef, but only some fields are used:
  * frameOptions, startOffset, and endOffset.
- *
- * This is only a subset of the full SQL:2008 frame_clause grammar.
- * We don't support <window frame exclusion> yet.
  */
 opt_frame_clause:
-			RANGE frame_extent
+			RANGE frame_extent opt_window_exclusion_clause
 				{
 					WindowDef *n = $2;
+					WindowDef *n2 = $3;
 					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
-					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
-										   FRAMEOPTION_END_VALUE_PRECEDING))
-						ereport(ERROR,
-								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
-								 parser_errposition(@1)));
-					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
-										   FRAMEOPTION_END_VALUE_FOLLOWING))
-						ereport(ERROR,
-								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
-								 parser_errposition(@1)));
+					if ((n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
+										   FRAMEOPTION_END_VALUE_PRECEDING)) ||
+						(n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
+										   FRAMEOPTION_END_VALUE_FOLLOWING)))
+							n->frameOptions |= FRAMEOPTION_RANGE_BETWEEN;
+					if (n2 != NULL)
+						n->frameOptions |= n2->frameOptions;
 					$$ = n;
 				}
-			| ROWS frame_extent
+			| ROWS frame_extent opt_window_exclusion_clause
 				{
 					WindowDef *n = $2;
+					WindowDef *n2 = $3;
 					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
+					if (n2 != NULL)
+						n->frameOptions |= n2->frameOptions;
+					$$ = n;
+				}
+			| GROUPS frame_extent opt_window_exclusion_clause
+				{
+					WindowDef *n = $2;
+					WindowDef *n2 = $3;
+					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
+					if ((n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
+										   FRAMEOPTION_END_VALUE_PRECEDING)) ||
+						(n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
+										   FRAMEOPTION_END_VALUE_FOLLOWING)))
+							n->frameOptions |= FRAMEOPTION_GROUPS_BETWEEN;
+					if (n2 != NULL)
+						n->frameOptions |= n2->frameOptions;
 					$$ = n;
 				}
 			| /*EMPTY*/
@@ -14166,6 +14176,34 @@ frame_bound:
 				}
 		;
 
+opt_window_exclusion_clause:
+			EXCLUDE CURRENT_P ROW
+				{
+					WindowDef *n = makeNode(WindowDef);
+					n->frameOptions = FRAMEOPTION_EXCLUDE_CURRENT;
+					$$ = n;
+				}
+			| EXCLUDE GROUP_P
+				{
+					WindowDef *n = makeNode(WindowDef);
+					n->frameOptions = FRAMEOPTION_EXCLUDE_GROUP;
+					$$ = n;
+				}
+			| EXCLUDE TIES
+				{
+					WindowDef *n = makeNode(WindowDef);
+					n->frameOptions = FRAMEOPTION_EXCLUDE_TIES;
+					$$ = n;
+				}
+			| EXCLUDE NO OTHERS
+				{
+					WindowDef *n = makeNode(WindowDef);
+					n->frameOptions = FRAMEOPTION_EXCLUDE_NO_OTHERS;
+					$$ = n;
+				}
+			| /*EMPTY*/								{ $$ = NULL; }
+		;
+
 
 /*
  * Supporting nonterminals for expressions.
@@ -15027,6 +15065,7 @@ unreserved_keyword:
 			| GENERATED
 			| GLOBAL
 			| GRANTED
+			| GROUPS
 			| HANDLER
 			| HEADER_P
 			| HOLD
@@ -15092,6 +15131,7 @@ unreserved_keyword:
 			| OPTION
 			| OPTIONS
 			| ORDINALITY
+			| OTHERS
 			| OVER
 			| OVERRIDING
 			| OWNED
@@ -15182,6 +15222,7 @@ unreserved_keyword:
 			| TEMPLATE
 			| TEMPORARY
 			| TEXT_P
+			| TIES
 			| TRANSACTION
 			| TRANSFORM
 			| TRIGGER
diff --git a/src/backend/parser/parse_agg.c b/src/backend/parser/parse_agg.c
index 6a9f1b0217..747139489a 100644
--- a/src/backend/parser/parse_agg.c
+++ b/src/backend/parser/parse_agg.c
@@ -420,6 +420,13 @@ check_agglevels_and_constraints(ParseState *pstate, Node *expr)
 				err = _("grouping operations are not allowed in window ROWS");
 
 			break;
+		case EXPR_KIND_WINDOW_FRAME_GROUPS:
+			if (isAgg)
+				err = _("aggregate functions are not allowed in window GROUPS");
+			else
+				err = _("grouping operations are not allowed in window GROUPS");
+
+			break;
 		case EXPR_KIND_SELECT_TARGET:
 			/* okay */
 			break;
@@ -835,6 +842,7 @@ transformWindowFuncCall(ParseState *pstate, WindowFunc *wfunc,
 		case EXPR_KIND_WINDOW_ORDER:
 		case EXPR_KIND_WINDOW_FRAME_RANGE:
 		case EXPR_KIND_WINDOW_FRAME_ROWS:
+		case EXPR_KIND_WINDOW_FRAME_GROUPS:
 			err = _("window functions are not allowed in window definitions");
 			break;
 		case EXPR_KIND_SELECT_TARGET:
diff --git a/src/backend/parser/parse_clause.c b/src/backend/parser/parse_clause.c
index 9fbcfd4fa6..d1f6ec4f2a 100644
--- a/src/backend/parser/parse_clause.c
+++ b/src/backend/parser/parse_clause.c
@@ -17,13 +17,17 @@
 
 #include "miscadmin.h"
 
+#include "access/amvalidate.h"
 #include "access/heapam.h"
+#include "access/htup_details.h"
 #include "access/tsmapi.h"
 #include "catalog/catalog.h"
 #include "catalog/heap.h"
 #include "catalog/pg_am.h"
+#include "catalog/pg_amproc.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_constraint_fn.h"
+#include "catalog/pg_opfamily.h"
 #include "catalog/pg_type.h"
 #include "commands/defrem.h"
 #include "nodes/makefuncs.h"
@@ -45,6 +49,7 @@
 #include "rewrite/rewriteManip.h"
 #include "utils/guc.h"
 #include "utils/lsyscache.h"
+#include "utils/syscache.h"
 #include "utils/rel.h"
 
 
@@ -96,6 +101,8 @@ static List *addTargetToGroupList(ParseState *pstate, TargetEntry *tle,
 static WindowClause *findWindowClause(List *wclist, const char *name);
 static Node *transformFrameOffset(ParseState *pstate, int frameOptions,
 					 Node *clause);
+static void getRangeBetweenFuncOid(ParseState *pstate, WindowDef  *windef,
+					 SortBy *sortby, Node *offset, Oid sortOid, Oid *rangeOid);
 
 
 /*
@@ -2608,6 +2615,29 @@ transformSortClause(ParseState *pstate,
 	return sortlist;
 }
 
+static void
+getRangeBetweenFuncOid(ParseState *pstate, WindowDef  *windef, SortBy *sortby,
+					   Node *offset, Oid sortOid, Oid *rangeOid)
+{
+	CatCList		*proclist;
+	HeapTuple		 proctup;
+	Form_pg_amproc	 procform;
+	Oid				 offsetOid = exprType(offset);
+
+	proclist = SearchSysCacheList4(AMPROCNUM, ObjectIdGetDatum(IN_RANGE_BTREE_FAM_OID),
+								   sortOid, offsetOid,
+								   sortby->sortby_dir == SORTBY_DESC ? 2 : 1);
+	if (proclist->n_members != 1)
+			ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("no in_range function for given types"),
+					parser_errposition(pstate, windef->location)));
+	proctup = &proclist->members[0]->tuple;
+	procform = (Form_pg_amproc) GETSTRUCT(proctup);
+	*rangeOid = procform->amproc;
+	ReleaseSysCacheList(proclist);
+}
+
 /*
  * transformWindowDefinitions -
  *		transform window definitions (WindowDef to WindowClause)
@@ -2753,6 +2783,7 @@ transformWindowDefinitions(ParseState *pstate,
 					 parser_errposition(pstate, windef->location)));
 		}
 		wc->frameOptions = windef->frameOptions;
+
 		/* Process frame offset expressions */
 		wc->startOffset = transformFrameOffset(pstate, wc->frameOptions,
 											   windef->startOffset);
@@ -2760,9 +2791,35 @@ transformWindowDefinitions(ParseState *pstate,
 											 windef->endOffset);
 		wc->winref = winref;
 
+		/* The RANGE BETWEEN clause requires exactly one ORDER BY column,
+		 * of either an int or date/time type and start/end values to match by type.
+		 */
+		if (wc->frameOptions & FRAMEOPTION_RANGE_BETWEEN)
+		{
+			SortBy		*sortby;
+			TargetEntry *tle;
+			Oid			sortOid;
+
+			if (list_length(orderClause) != 1)
+				ereport(ERROR,
+						(errcode(ERRCODE_WINDOWING_ERROR),
+						errmsg("RANGE clause requires exactly one ORDER BY column"),
+						parser_errposition(pstate, windef->location)));
+			sortby = (SortBy *) lfirst(list_head(windef->orderClause));
+			tle = findTargetlistEntrySQL99(pstate, sortby->node,
+										   targetlist, EXPR_KIND_WINDOW_ORDER);
+
+			/* Check that the sortOid and start/end offset Oids match */
+			sortOid = exprType((Node *) tle->expr);
+			if (wc->frameOptions & FRAMEOPTION_START_VALUE)
+				getRangeBetweenFuncOid(pstate, windef, sortby, wc->startOffset, sortOid, &wc->startRangeOid);
+
+			if (wc->frameOptions & FRAMEOPTION_END_VALUE)
+				getRangeBetweenFuncOid(pstate, windef, sortby, wc->endOffset, sortOid, &wc->endRangeOid);
+		}
+
 		result = lappend(result, wc);
 	}
-
 	return result;
 }
 
@@ -3515,14 +3572,18 @@ transformFrameOffset(ParseState *pstate, int frameOptions, Node *clause)
 	{
 		/* Transform the raw expression tree */
 		node = transformExpr(pstate, clause, EXPR_KIND_WINDOW_FRAME_RANGE);
+		constructName = "RANGE";
+	}
+	else if (frameOptions & FRAMEOPTION_GROUPS)
+	{
+		/* Transform the raw expression tree */
+		node = transformExpr(pstate, clause, EXPR_KIND_WINDOW_FRAME_GROUPS);
 
 		/*
-		 * this needs a lot of thought to decide how to support in the context
-		 * of Postgres' extensible datatype framework
+		 * Like LIMIT clause, simply coerce to int8
 		 */
-		constructName = "RANGE";
-		/* error was already thrown by gram.y, this is just a backstop */
-		elog(ERROR, "window frame with value offset is not implemented");
+		constructName = "GROUPS";
+		node = coerce_to_specific_type(pstate, node, INT8OID, constructName);
 	}
 	else
 	{
diff --git a/src/backend/parser/parse_expr.c b/src/backend/parser/parse_expr.c
index b2f5e46e3b..d45926f27f 100644
--- a/src/backend/parser/parse_expr.c
+++ b/src/backend/parser/parse_expr.c
@@ -1805,6 +1805,7 @@ transformSubLink(ParseState *pstate, SubLink *sublink)
 		case EXPR_KIND_WINDOW_ORDER:
 		case EXPR_KIND_WINDOW_FRAME_RANGE:
 		case EXPR_KIND_WINDOW_FRAME_ROWS:
+		case EXPR_KIND_WINDOW_FRAME_GROUPS:
 		case EXPR_KIND_SELECT_TARGET:
 		case EXPR_KIND_INSERT_TARGET:
 		case EXPR_KIND_UPDATE_SOURCE:
@@ -3428,6 +3429,8 @@ ParseExprKindName(ParseExprKind exprKind)
 			return "window RANGE";
 		case EXPR_KIND_WINDOW_FRAME_ROWS:
 			return "window ROWS";
+		case EXPR_KIND_WINDOW_FRAME_GROUPS:
+			return "window GROUPS";
 		case EXPR_KIND_SELECT_TARGET:
 			return "SELECT";
 		case EXPR_KIND_INSERT_TARGET:
diff --git a/src/backend/parser/parse_func.c b/src/backend/parser/parse_func.c
index ffae0f3cf3..4a7bc77c0f 100644
--- a/src/backend/parser/parse_func.c
+++ b/src/backend/parser/parse_func.c
@@ -2227,6 +2227,7 @@ check_srf_call_placement(ParseState *pstate, Node *last_srf, int location)
 			break;
 		case EXPR_KIND_WINDOW_FRAME_RANGE:
 		case EXPR_KIND_WINDOW_FRAME_ROWS:
+		case EXPR_KIND_WINDOW_FRAME_GROUPS:
 			err = _("set-returning functions are not allowed in window definitions");
 			break;
 		case EXPR_KIND_SELECT_TARGET:
diff --git a/src/backend/utils/adt/date.c b/src/backend/utils/adt/date.c
index 747ef49789..3958ae5cd8 100644
--- a/src/backend/utils/adt/date.c
+++ b/src/backend/utils/adt/date.c
@@ -44,6 +44,9 @@
 static int	tm2time(struct pg_tm *tm, fsec_t fsec, TimeADT *result);
 static int	tm2timetz(struct pg_tm *tm, fsec_t fsec, int tz, TimeTzADT *result);
 static void AdjustTimeForTypmod(TimeADT *time, int32 typmod);
+static bool in_range_internal(Datum curr, Datum slot, Datum offset, bool preceding, bool end,
+							   PGFunction miIntervalFunc, PGFunction plIntervalFunc,
+							   PGFunction gtComparatorFunc, PGFunction ltComparatorFunc, bool asc);
 
 
 /* common code for timetypmodin and timetztypmodin */
@@ -2754,3 +2757,89 @@ timetz_izone(PG_FUNCTION_ARGS)
 
 	PG_RETURN_TIMETZADT_P(result);
 }
+
+
+/*----------------------------------------------------------
+ *	In RANGE procedures on dates.
+ *---------------------------------------------------------*/
+
+static bool in_range_internal(Datum curr, Datum slot, Datum offset, bool preceding, bool end,
+							   PGFunction miIntervalFunc, PGFunction plIntervalFunc,
+							   PGFunction gtComparatorFunc, PGFunction ltComparatorFunc, bool asc)
+{
+	Datum		result;
+
+	if (preceding)
+		result = DirectFunctionCall2(asc ? miIntervalFunc : plIntervalFunc, curr, offset);
+	else
+		result = DirectFunctionCall2(asc ? plIntervalFunc : miIntervalFunc, curr, offset);
+
+	if (end)
+	{
+		if (DatumGetBool(DirectFunctionCall2(asc ? gtComparatorFunc : ltComparatorFunc, slot, result)))
+			return false;
+	}
+	else
+	{
+		if (DatumGetBool(DirectFunctionCall2(asc ? ltComparatorFunc : gtComparatorFunc, slot, result)))
+			return false;
+	}
+
+	return true;
+}
+
+Datum
+in_range_timetz_interval_asc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									 PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 timetz_mi_interval, timetz_pl_interval,
+									 timetz_gt, timetz_lt, true));
+}
+
+Datum
+in_range_timetz_interval_desc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0), PG_GETARG_DATUM(1), PG_GETARG_DATUM(2),
+									 PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 timetz_mi_interval, timetz_pl_interval,
+									 timetz_gt, timetz_lt, false));
+}
+
+Datum
+in_range_date_interval_asc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0),
+									 DirectFunctionCall1(date_timestamp, PG_GETARG_DATUM(1)),
+									 PG_GETARG_DATUM(2), PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 date_mi_interval, date_pl_interval,
+									 timestamp_gt, timestamp_lt, true));
+}
+
+Datum
+in_range_date_interval_desc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(PG_GETARG_DATUM(0),
+									 DirectFunctionCall1(date_timestamp, PG_GETARG_DATUM(1)),
+									 PG_GETARG_DATUM(2), PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 date_mi_interval, date_pl_interval,
+									 timestamp_gt, timestamp_lt, false));
+}
+
+Datum
+in_range_time_interval_asc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(DirectFunctionCall1(time_interval, PG_GETARG_DATUM(0)),
+									 DirectFunctionCall1(time_interval, PG_GETARG_DATUM(1)),
+									 PG_GETARG_DATUM(2), PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 interval_mi, interval_pl, interval_gt, interval_lt, true));
+}
+
+Datum
+in_range_time_interval_desc(PG_FUNCTION_ARGS)
+{
+	PG_RETURN_BOOL(in_range_internal(DirectFunctionCall1(time_interval, PG_GETARG_DATUM(0)),
+									 DirectFunctionCall1(time_interval, PG_GETARG_DATUM(1)),
+									 PG_GETARG_DATUM(2), PG_GETARG_BOOL(3), PG_GETARG_BOOL(4),
+									 interval_mi, interval_pl, interval_gt, interval_lt, false));
+}
diff --git a/src/backend/utils/adt/int.c b/src/backend/utils/adt/int.c
index 7352908365..a9d20dd752 100644
--- a/src/backend/utils/adt/int.c
+++ b/src/backend/utils/adt/int.c
@@ -307,8 +307,261 @@ int4send(PG_FUNCTION_ARGS)
 }
 
 
+/*----------------------------------------------------------
+ *	In RANGE procedures on 16-bit and 32-bit integers.
+ *---------------------------------------------------------*/
+
+Datum
+in_range_int4_int4_asc(PG_FUNCTION_ARGS)
+{
+	int32		curr = PG_GETARG_INT32(0);
+	int32		slot = PG_GETARG_INT32(1);
+	int32		offset = PG_GETARG_INT32(2);
+	bool		preceding = PG_GETARG_BOOL(3);
+	bool		end = PG_GETARG_BOOL(4);
+	int32		result;
+
+	if (offset < 0)
+		ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("RANGE offsets cannot be negative. invalid value %d", offset)));
+	if (preceding)
+		offset = -offset;
+
+	if (unlikely(pg_add_s32_overflow(curr, offset, &result)))
+		PG_RETURN_BOOL(true);
+
+	if (end)
+	{
+		if (slot > result)
+			PG_RETURN_BOOL(false);
+	}
+	else
+	{
+		if (slot < result)
+			PG_RETURN_BOOL(false);
+	}
+
+	PG_RETURN_BOOL(true);
+}
+
+Datum
+in_range_int4_int4_desc(PG_FUNCTION_ARGS)
+{
+	int32		curr = PG_GETARG_INT32(0);
+	int32		slot = PG_GETARG_INT32(1);
+	int32		offset = PG_GETARG_INT32(2);
+	bool		preceding = PG_GETARG_BOOL(3);
+	bool		end = PG_GETARG_BOOL(4);
+	int32		result;
+
+	if (offset < 0)
+		ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("RANGE offsets cannot be negative. invalid value %d", offset)));
+	if (!preceding)
+		offset = -offset;
+
+	if (unlikely(pg_add_s32_overflow(curr, offset, &result)))
+		PG_RETURN_BOOL(true);
+
+	if (end)
+	{
+		if (slot < result)
+			PG_RETURN_BOOL(false);
+	}
+	else
+	{
+		if (slot > result)
+			PG_RETURN_BOOL(false);
+	}
+
+	PG_RETURN_BOOL(true);
+}
+
+Datum
+in_range_int4_int8_asc(PG_FUNCTION_ARGS)
+{
+	Datum		offset32;
+	int64		offset64 = PG_GETARG_INT64(2);
+
+	offset32 = DirectFunctionCall1(int84, offset64);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int4_int4_asc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset32,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int4_int8_desc(PG_FUNCTION_ARGS)
+{
+	Datum		offset32;
+	int32		offset64 = PG_GETARG_INT64(2);
+
+	offset32 = DirectFunctionCall1(int84, offset64);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int4_int4_desc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset32,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int4_int2_asc(PG_FUNCTION_ARGS)
+{
+	Datum		offset32;
+	int16		offset16 = PG_GETARG_INT16(2);
+
+	offset32 = DirectFunctionCall1(i2toi4, offset16);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int4_int4_asc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset32,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int4_int2_desc(PG_FUNCTION_ARGS)
+{
+	Datum		offset32;
+	int16		offset16 = PG_GETARG_INT16(2);
+
+	offset32 = DirectFunctionCall1(i2toi4, offset16);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int4_int4_desc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset32,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int2_int2_asc(PG_FUNCTION_ARGS)
+{
+	int16		curr = PG_GETARG_INT16(0);
+	int16		slot = PG_GETARG_INT16(1);
+	int16		offset = PG_GETARG_INT16(2);
+	bool		preceding = PG_GETARG_BOOL(3);
+	bool		end = PG_GETARG_BOOL(4);
+	int16		result;
+
+	if (offset < 0)
+		ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("RANGE offsets cannot be negative. invalid value %d", offset)));
+	if (preceding)
+		offset = -offset;
+
+	if (unlikely(pg_add_s16_overflow(curr, offset, &result)))
+		PG_RETURN_BOOL(true);
+
+	if (end)
+	{
+		if (slot > result)
+			PG_RETURN_BOOL(false);
+	}
+	else
+	{
+		if (slot < result)
+			PG_RETURN_BOOL(false);
+	}
+
+	PG_RETURN_BOOL(true);
+}
+
+Datum
+in_range_int2_int2_desc(PG_FUNCTION_ARGS)
+{
+	int16		curr = PG_GETARG_INT16(0);
+	int16		slot = PG_GETARG_INT16(1);
+	int16		offset = PG_GETARG_INT16(2);
+	bool		preceding = PG_GETARG_BOOL(3);
+	bool		end = PG_GETARG_BOOL(4);
+	int16		result;
+
+	if (offset < 0)
+		ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("RANGE offsets cannot be negative. invalid value %d", offset)));
+	if (!preceding)
+		offset = -offset;
+
+	if (unlikely(pg_add_s16_overflow(curr, offset, &result)))
+		PG_RETURN_BOOL(true);
+
+	if (end)
+	{
+		if (slot < result)
+			PG_RETURN_BOOL(false);
+	}
+	else
+	{
+		if (slot > result)
+			PG_RETURN_BOOL(false);
+	}
+
+	PG_RETURN_BOOL(true);
+}
+
+Datum
+in_range_int2_int8_asc(PG_FUNCTION_ARGS)
+{
+	Datum		offset16;
+	int64		offset64 = PG_GETARG_INT64(2);
+
+	offset16 = DirectFunctionCall1(int82, offset64);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int2_int2_asc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset16,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int2_int8_desc(PG_FUNCTION_ARGS)
+{
+	Datum		offset16;
+	int32		offset64 = PG_GETARG_INT64(2);
+
+	offset16 = DirectFunctionCall1(int82, offset64);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int2_int2_desc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset16,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int2_int4_asc(PG_FUNCTION_ARGS)
+{
+	Datum		offset16;
+	int32		offset32 = PG_GETARG_INT32(2);
+
+	offset16 = DirectFunctionCall1(i4toi2, offset32);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int2_int2_asc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset16,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int2_int4_desc(PG_FUNCTION_ARGS)
+{
+	Datum		offset16;
+	int32		offset32 = PG_GETARG_INT32(2);
+
+	offset16 = DirectFunctionCall1(i4toi2, offset32);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int2_int2_desc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset16,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+
 /*
- *		===================
+ *		===================in_range_
  *		CONVERSION ROUTINES
  *		===================
  */
diff --git a/src/backend/utils/adt/int8.c b/src/backend/utils/adt/int8.c
index ae6a4683d4..a72047edb9 100644
--- a/src/backend/utils/adt/int8.c
+++ b/src/backend/utils/adt/int8.c
@@ -1101,6 +1101,136 @@ int8shr(PG_FUNCTION_ARGS)
 	PG_RETURN_INT64(arg1 >> arg2);
 }
 
+
+/*----------------------------------------------------------
+ *	In RANGE procedures on 64-bit integers.
+ *---------------------------------------------------------*/
+
+Datum
+in_range_int8_int8_asc(PG_FUNCTION_ARGS)
+{
+	int64		curr = PG_GETARG_INT64(0);
+	int64		slot = PG_GETARG_INT64(1);
+	int64		offset = PG_GETARG_INT64(2);
+	bool		preceding = PG_GETARG_BOOL(3);
+	bool		end = PG_GETARG_BOOL(4);
+	int64		result;
+
+	if (offset < 0)
+		ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("RANGE offsets cannot be negative. invalid value %zd", offset)));
+	if (preceding)
+		offset = -offset;
+
+	if (unlikely(pg_add_s64_overflow(curr, offset, &result)))
+		PG_RETURN_BOOL(true);
+
+	if (end)
+	{
+		if (slot > result)
+			PG_RETURN_BOOL(false);
+	}
+	else
+	{
+		if (slot < result)
+			PG_RETURN_BOOL(false);
+	}
+
+	PG_RETURN_BOOL(true);
+}
+
+Datum
+in_range_int8_int8_desc(PG_FUNCTION_ARGS)
+{
+	int64		curr = PG_GETARG_INT64(0);
+	int64		slot = PG_GETARG_INT64(1);
+	int64		offset = PG_GETARG_INT64(2);
+	bool		preceding = PG_GETARG_BOOL(3);
+	bool		end = PG_GETARG_BOOL(4);
+	int64		result;
+
+	if (offset < 0)
+		ereport(ERROR,
+					(errcode(ERRCODE_WINDOWING_ERROR),
+					errmsg("RANGE offsets cannot be negative. invalid value %zd", offset)));
+	if (!preceding)
+		offset = -offset;
+
+	if (unlikely(pg_add_s64_overflow(curr, offset, &result)))
+		PG_RETURN_BOOL(true);
+
+	if (end)
+	{
+		if (slot < result)
+			PG_RETURN_BOOL(false);
+	}
+	else
+	{
+		if (slot > result)
+			PG_RETURN_BOOL(false);
+	}
+
+	PG_RETURN_BOOL(true);
+}
+
+Datum
+in_range_int8_int4_asc(PG_FUNCTION_ARGS)
+{
+	Datum		offset64;
+	int32		offset32 = PG_GETARG_INT32(2);
+
+	offset64 = DirectFunctionCall1(int48, offset32);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int8_int8_asc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset64,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int8_int4_desc(PG_FUNCTION_ARGS)
+{
+	Datum		offset64;
+	int32		offset32 = PG_GETARG_INT32(2);
+
+	offset64 = DirectFunctionCall1(int48, offset32);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int8_int8_desc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset64,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int8_int2_asc(PG_FUNCTION_ARGS)
+{
+	Datum		offset64;
+	int16		offset16 = PG_GETARG_INT16(2);
+
+	offset64 = DirectFunctionCall1(int28, offset16);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int8_int8_asc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset64,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+Datum
+in_range_int8_int2_desc(PG_FUNCTION_ARGS)
+{
+	Datum		offset64;
+	int16		offset16 = PG_GETARG_INT16(2);
+
+	offset64 = DirectFunctionCall1(int28, offset16);
+	PG_RETURN_BOOL(DirectFunctionCall5(in_range_int8_int8_desc, PG_GETARG_DATUM(0),
+									   PG_GETARG_DATUM(1),
+									   offset64,
+									   PG_GETARG_DATUM(3),
+									   PG_GETARG_DATUM(4)));
+}
+
+
 /*----------------------------------------------------------
  *	Conversion operators.
  *---------------------------------------------------------*/
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index c5f5a1ca3f..3d07a648b4 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -5877,6 +5877,8 @@ get_rule_windowspec(WindowClause *wc, List *targetList,
 			appendStringInfoString(buf, "RANGE ");
 		else if (wc->frameOptions & FRAMEOPTION_ROWS)
 			appendStringInfoString(buf, "ROWS ");
+		else if (wc->frameOptions & FRAMEOPTION_GROUPS)
+			appendStringInfoString(buf, "GROUPS ");
 		else
 			Assert(false);
 		if (wc->frameOptions & FRAMEOPTION_BETWEEN)
@@ -5917,6 +5919,14 @@ get_rule_windowspec(WindowClause *wc, List *targetList,
 			else
 				Assert(false);
 		}
+		if (wc->frameOptions & FRAMEOPTION_EXCLUDE_CURRENT)
+			appendStringInfoString(buf, "EXCLUDE CURRENT ROW ");
+		else if (wc->frameOptions & FRAMEOPTION_EXCLUDE_GROUP)
+			appendStringInfoString(buf, "EXCLUDE GROUP ");
+		else if (wc->frameOptions & FRAMEOPTION_EXCLUDE_TIES)
+			appendStringInfoString(buf, "EXCLUDE TIES ");
+		else if (wc->frameOptions & FRAMEOPTION_EXCLUDE_NO_OTHERS)
+			appendStringInfoString(buf, "EXCLUDE NO OTHERS ");
 		/* we will now have a trailing space; remove it */
 		buf->len--;
 	}
